package com.tiger.bmpeb.sample6;

import javax.naming.*;
import javax.ejb.*;
import java.sql.*;
import javax.sql.*;

public class CustomerBean implements javax.ejb.EntityBean {
    private javax.ejb.EntityContext entityContext = null;
    
    private CustomerID customerID;
    private String name;
    private int age;
    public CustomerID getCustomerID() {
        return this.customerID;
    }
    public void setCustomerID(CustomerID customerID) {
        this.customerID = customerID;
    }
    public String getName() {
        return this.name;
    }
    public void setName(String name) {
        this.name = name;
    }
    public int getAge() {
        return this.age;
    }
    public void setAge(int age) {
        this.age = age;
    }
    
    public CustomerID ejbCreate(CustomerID customerID, String name, int age)
    throws javax.ejb.CreateException {
        setCustomerID(customerID);
        setName(name);
        setAge(age);
        Connection con = null;
        PreparedStatement ps = null;
        try {
            InitialContext ctx = new InitialContext();
            DataSource ds = (javax.sql.DataSource)ctx.lookup("java:comp/env/jdbc/Database");
            con = ds.getConnection();
            ps = con.prepareStatement(
            "INSERT INTO CUSTOMER (CUSTOMERID, NAME, AGE) VALUES(?, ?, ?)");
            ps.setInt(1, customerID.getCustomerID());
            ps.setString(2, name);
            ps.setInt(3, age);
            if(ps.executeUpdate() != 1)
                throw new CreateException("Customer Bean̐Ɏs܂");
        }
        catch(SQLException e) {
            throw new EJBException(e);
        }
        catch(NamingException e) {
            throw new EJBException(e);
        }
        finally {
            try {
                if(ps != null)
                    ps.close();
                if(con != null)
                    con.close();
            }
            catch(SQLException ex) {
                throw new EJBException(ex);
            }
        }
        return customerID;
    }
    
    public void ejbPostCreate(CustomerID customerID, String name, int age) {
    }
    
    public void setEntityContext(javax.ejb.EntityContext entityContext) {
        this.entityContext = entityContext;
    }
    
    public void unsetEntityContext() {
        this.entityContext = null;
    }
    
    public CustomerID ejbFindByPrimaryKey(CustomerID customerID) throws FinderException {
        Connection con = null;
        PreparedStatement ps = null;
        ResultSet rs = null;
        try {
            InitialContext ctx = new InitialContext();
            DataSource ds = (javax.sql.DataSource)ctx.lookup("java:comp/env/jdbc/Database");
            con = ds.getConnection();
            ps = con.prepareStatement(
            "SELECT CUSTOMERID FROM CUSTOMER WHERE CUSTOMERID = ?");
            ps.setInt(1, customerID.getCustomerID());
            rs = ps.executeQuery();
            if(!rs.next())
                throw new ObjectNotFoundException("YCustomer Bean܂ł");
        }
        catch(SQLException e) {
            throw new EJBException(e);
        }
        catch(NamingException e) {
            throw new EJBException(e);
        }
        finally {
            try {
                if(rs != null)
                    rs.close();
                if(ps != null)
                    ps.close();
                if(con != null)
                    con.close();
            }
            catch(SQLException ex) {
                throw new EJBException(ex);
            }
        }
        return customerID;
    }
    
    public void ejbLoad() {
        CustomerID customerID = (CustomerID)entityContext.getPrimaryKey();
        Connection con = null;
        PreparedStatement ps = null;
        ResultSet rs = null;
        try {
            InitialContext ctx = new InitialContext();
            DataSource ds = (javax.sql.DataSource)ctx.lookup("java:comp/env/jdbc/Database");
            con = ds.getConnection();
            ps = con.prepareStatement(
            "SELECT NAME, AGE FROM CUSTOMER WHERE CUSTOMERID = ?");
            ps.setInt(1, customerID.getCustomerID());
            rs = ps.executeQuery();
            if(!rs.next()) {
                throw new EJBException("YCustomer Bean܂ł");
            }
            else {
                setCustomerID(customerID);
                setName(rs.getString("NAME"));
                setAge(rs.getInt("AGE"));
            }
        }
        catch(SQLException e) {
            throw new EJBException(e);
        }
        catch(NamingException e) {
            throw new EJBException(e);
        }
        finally {
            try {
                if(rs != null)
                    rs.close();
                if(ps != null)
                    ps.close();
                if(con != null)
                    con.close();
            }
            catch(SQLException ex) {
                throw new EJBException(ex);
            }
        }
    }
    
    public void ejbStore() {
        CustomerID customerID = getCustomerID();
        Connection con = null;
        PreparedStatement ps = null;
        try {
            InitialContext ctx = new InitialContext();
            DataSource ds = (javax.sql.DataSource)ctx.lookup("java:comp/env/jdbc/Database");
            con = ds.getConnection();
            ps = con.prepareStatement(
            "UPDATE CUSTOMER SET NAME = ?, AGE = ? WHERE CUSTOMERID = ?");
            ps.setString(1, getName());
            ps.setInt(2, getAge());
            ps.setInt(3, customerID.getCustomerID());
            if(ps.executeUpdate() != 1) {
                throw new EJBException("ejbStoreŃG[܂");
            }
        }
        catch(SQLException e) {
            throw new EJBException(e);
        }
        catch(NamingException e) {
            throw new EJBException(e);
        }
        finally {
            try {
                if(ps != null)
                    ps.close();
                if(con != null)
                    con.close();
            }
            catch(SQLException ex) {
                throw new EJBException(ex);
            }
        }
    }
    
    public void ejbActivate() {
    }
    
    public void ejbPassivate() {
    }
    
    public void ejbRemove() {
        CustomerID customerID = getCustomerID();
        Connection con = null;
        PreparedStatement ps = null;
        try {
            InitialContext ctx = new InitialContext();
            DataSource ds = (javax.sql.DataSource)ctx.lookup("java:comp/env/jdbc/Database");
            con = ds.getConnection();
            ps = con.prepareStatement(
            "DELETE FROM CUSTOMER WHERE CUSTOMERID = ?");
            ps.setInt(1, customerID.getCustomerID());
            if(ps.executeUpdate() != 1) {
                throw new EJBException("ejbRemoveŃG[܂");
            }
        }
        catch(SQLException e) {
            throw new EJBException(e);
        }
        catch(NamingException e) {
            throw new EJBException(e);
        }
        finally {
            try {
                if(ps != null)
                    ps.close();
                if(con != null)
                    con.close();
            }
            catch(SQLException ex) {
                throw new EJBException(ex);
            }
        }
    }
}
