package com.tiger.ejbql.sample2;

import java.util.*;
import javax.ejb.*;
import javax.naming.*;

public class TestBean implements javax.ejb.SessionBean {
    private javax.ejb.SessionContext sessionContext = null;
    
    public void setSessionContext(javax.ejb.SessionContext sessionContext) {
        this.sessionContext = sessionContext;
    }
    
    public void createTestData() {
        try {
            InitialContext ctx = new InitialContext();
            AHome aHome = (AHome)ctx.lookup("java:comp/env/ejb/ABean");
            BHome bHome = (BHome)ctx.lookup("java:comp/env/ejb/BBean");
            CHome cHome = (CHome)ctx.lookup("java:comp/env/ejb/CBean");
            
            // eXgf[^̍쐬
            A a1 = aHome.create(new Integer(1), "A1");
            A a2 = aHome.create(new Integer(2), "A2");
            
            B b1 = bHome.create(new Integer(1), "B1");
            B b2 = bHome.create(new Integer(2), "B2");
            B b3 = bHome.create(new Integer(3), "B1");
            B b4 = bHome.create(new Integer(4), "B1");
            
            C c1 = cHome.create(new Integer(1), "C1");
            C c2 = cHome.create(new Integer(2), "C1");
            C c3 = cHome.create(new Integer(3), "C2");
            
            a1.getB().add(b1);
            b1.getC().add(c1);
            a1.getB().add(b2);
            b2.getC().add(c2);
            
            a2.getB().add(b3);
            b3.getC().add(c3);
            a2.getB().add(b4);
        }
        catch(javax.naming.NamingException e) {
            throw new javax.ejb.EJBException(e);
        }
        catch(javax.ejb.CreateException e) {
            throw new javax.ejb.EJBException(e);
        }
    }
    
    public void test() {
        try {
            InitialContext ctx = new InitialContext();
            AHome aHome = (AHome)ctx.lookup("java:comp/env/ejb/ABean");
            BHome bHome = (BHome)ctx.lookup("java:comp/env/ejb/BBean");
            CHome cHome = (CHome)ctx.lookup("java:comp/env/ejb/CBean");
            
            System.out.println("findByNames1@BHome:");
            Iterator namesB1Results = bHome.findByNames1("A1", "B1").iterator();
            while(namesB1Results.hasNext()) {
                B b = (B)namesB1Results.next();
                System.out.println("id = " + b.getId() +
                " name = " + b.getName());
            }
            System.out.println();
            System.out.println("findByNames2@BHome:");
            Iterator namesB2Results = bHome.findByNames2("A1", "B1").iterator();
            while(namesB2Results.hasNext()) {
                B b = (B)namesB2Results.next();
                System.out.println("id = " + b.getId() +
                " name = " + b.getName());
            }
            System.out.println();
            System.out.println("findByNames3@BHome:");
            Iterator namesB3Results = bHome.findByNames3("A1", "B1").iterator();
            while(namesB3Results.hasNext()) {
                B b = (B)namesB3Results.next();
                System.out.println("id = " + b.getId() +
                " name = " + b.getName());
            }
            
            System.out.println();
            System.out.println("findByNames1@CHome:");
            Iterator namesC1Results = cHome.findByNames1("A1", "B1", "C1").iterator();
            while(namesC1Results.hasNext()) {
                C c = (C)namesC1Results.next();
                System.out.println("id = " + c.getId() +
                " name = " + c.getName());
            }
            System.out.println();
            System.out.println("findByNames2@CHome:");
            Iterator namesC2Results = cHome.findByNames2("A1", "B1", "C1").iterator();
            while(namesC2Results.hasNext()) {
                C c = (C)namesC2Results.next();
                System.out.println("id = " + c.getId() +
                " name = " + c.getName());
            }
            System.out.println();
            System.out.println("findByNames3@CHome:");
            Iterator namesC3Results = cHome.findByNames3("A1", "B1", "C1").iterator();
            while(namesC3Results.hasNext()) {
                C c = (C)namesC3Results.next();
                System.out.println("id = " + c.getId() +
                " name = " + c.getName());
            }
        }
        catch(javax.naming.NamingException e) {
            throw new javax.ejb.EJBException(e);
        }
        catch(javax.ejb.FinderException e) {
            throw new javax.ejb.EJBException(e);
        }
    }
    
    public void ejbCreate() {}
    
    public void ejbActivate() {}
    
    public void ejbPassivate() {}
    
    public void ejbRemove() {}
}
