package com.tiger.ejbql.sample3;

import java.util.*;
import javax.ejb.*;
import javax.naming.*;

public class TestBean implements javax.ejb.SessionBean {
    private javax.ejb.SessionContext sessionContext = null;
    
    public void setSessionContext(javax.ejb.SessionContext sessionContext) {
        this.sessionContext = sessionContext;
    }
    
    public void createTestData() {
        try {
            InitialContext ctx = new InitialContext();
            AHome aHome = (AHome)ctx.lookup("java:comp/env/ejb/ABean");
            BHome bHome = (BHome)ctx.lookup("java:comp/env/ejb/BBean");
            
            // eXgf[^̍쐬
            A a1 = aHome.create(new Integer(1), "A1", 2.0);
            A a2 = aHome.create(new Integer(2), "A2", 3.0);
            A a3 = aHome.create(new Integer(3), "A1A2", 3.25);
            A a4 = aHome.create(new Integer(4), "A2A1", -4.15);
            A a5 = aHome.create(new Integer(5), null, 2.95);
            
            B b1 = bHome.create(new Integer(1), "B1", 1.0);
            B b2 = bHome.create(new Integer(2), "B2", 1.15);
            B b3 = bHome.create(new Integer(3), "B3", 2.0);
            B b4 = bHome.create(new Integer(4), "B4", -2.0);
            
            a1.getB().add(b1);
            a1.getB().add(b2);
            
            a2.getB().add(b3);
            
            a3.getB().add(b4);
        }
        catch(javax.naming.NamingException e) {
            throw new javax.ejb.EJBException(e);
        }
        catch(javax.ejb.CreateException e) {
            throw new javax.ejb.EJBException(e);
        }
    }
    
    public void test() {
        try {
            InitialContext ctx = new InitialContext();
            AHome aHome = (AHome)ctx.lookup("java:comp/env/ejb/ABean");
            BHome bHome = (BHome)ctx.lookup("java:comp/env/ejb/BBean");
            
            // finder\bh
            System.out.println("BETWEEN: BETWEEN (2.0, 3.0)");
            Iterator betweenResults = aHome.findTestBetween(2.0, 3.0).iterator();
            while(betweenResults.hasNext()) {
                A a = (A)betweenResults.next();
                System.out.println("id = " + a.getId() +
                " name = " + a.getName() +
                " value = " + a.getValue());
            }
            System.out.println();
            System.out.println("IN: IN('A1', 'A2', 'A3')");
            Iterator inResults = aHome.findTestIn().iterator();
            while(inResults.hasNext()) {
                A a = (A)inResults.next();
                System.out.println("id = " + a.getId() +
                " name = " + a.getName() +
                " value = " + a.getValue());
            }
            System.out.println();
            System.out.println("LIKE: LIKE '%1'");
            Iterator likeResults = aHome.findTestLike().iterator();
            while(likeResults.hasNext()) {
                A a = (A)likeResults.next();
                System.out.println("id = " + a.getId() +
                " name = " + a.getName() +
                " value = " + a.getValue());
            }
            System.out.println();
            System.out.println("IS NULL:");
            Iterator isNullResults = aHome.findTestIsNull().iterator();
            while(isNullResults.hasNext()) {
                A a = (A)isNullResults.next();
                System.out.println("id = " + a.getId() +
                " name = " + a.getName() +
                " value = " + a.getValue());
            }
            System.out.println();
            System.out.println("IS EMPTY:");
            Iterator isEmptyResults = aHome.findTestIsEmpty().iterator();
            while(isEmptyResults.hasNext()) {
                A a = (A)isEmptyResults.next();
                System.out.println("id = " + a.getId() +
                " name = " + a.getName() +
                " value = " + a.getValue());
            }
            aHome.test();
        }
        catch(javax.naming.NamingException e) {
            throw new javax.ejb.EJBException(e);
        }
        catch(javax.ejb.FinderException e) {
            throw new javax.ejb.EJBException(e);
        }
    }
    
    public void ejbCreate() {}
    
    public void ejbActivate() {}
    
    public void ejbPassivate() {}
    
    public void ejbRemove() {}
}
