package com.tiger.statefulsb.sample2;

import javax.ejb.*;
import java.util.*;

public class ShoppingCartBean implements javax.ejb.SessionBean {
    public final static int DEFAULT_MAX_SIZE = 20;
    public final static String SPECIAL_PRESENT = "CD-RfBA10";
    
    private javax.ejb.SessionContext sessionContext = null;
    private Vector itemNameList = null;
    private Vector itemPriceList = null;
    private int maxSize;
    
    public void setSessionContext(javax.ejb.SessionContext sessionContext)
    throws javax.ejb.EJBException, java.rmi.RemoteException {
        System.out.println("ShoppingCartBeansetSessionContextĂ΂܂");
        this.sessionContext = sessionContext;
    }
    
    // R|[lgC^[tFCXcreate()\bhɑΉ
    public void ejbCreate() {
        System.out.println("ShoppingCartBeanejbCreateĂ΂܂");
        this.itemNameList = new Vector();
        this.itemPriceList = new Vector();
        this.maxSize = DEFAULT_MAX_SIZE;
    }
    
    // R|[lgC^[tFCXcreate(int maxSize)\bhɑΉ
    public void ejbCreate(int maxSize) {
        System.out.println("ShoppingCartBeanejbCreate(int maxSize)Ă΂܂");
        this.itemNameList = new Vector();
        this.itemPriceList = new Vector();
        this.maxSize = maxSize;
    }
    
    // R|[lgC^[tFCXcreateWithSpecialPresents()\bhɑΉ
    public void ejbCreateWithSpecialPresents() {
        System.out.println("ShoppingCartBeanejbCreateWithSpecialPresents()Ă΂܂");
        this.itemNameList = new Vector();
        this.itemPriceList = new Vector();
        this.maxSize = DEFAULT_MAX_SIZE;
        this.itemNameList.addElement(SPECIAL_PRESENT);
        this.itemPriceList.addElement(new Integer(0));
    }
    
    // R|[lgC^[tFCXcreateWithSpecialPresents(int maxSize)\bhɑΉ
    public void ejbCreateWithSpecialPresents(int maxSize) {
        System.out.println("ShoppingCartBeanejbCreateWithSpecialPresents(int maxSize)Ă΂܂");
        this.itemNameList = new Vector();
        this.itemPriceList = new Vector();
        this.maxSize = maxSize;
        this.itemNameList.addElement(SPECIAL_PRESENT);
        this.itemPriceList.addElement(new Integer(0));
    }
    
    public void add(String itemName, int itemPrice) {
        System.out.println("ShoppingCartBeanaddĂ΂܂");
        
        if(itemNameList.size() >= maxSize)
            return;
        
        System.out.println("i=" + itemName + ", i=" + itemPrice);
        this.itemNameList.addElement(itemName);
        this.itemPriceList.addElement(new Integer(itemPrice));
    }
    
    public void ejbActivate() throws javax.ejb.EJBException, java.rmi.RemoteException {
        System.out.println("ShoppingCartBeanejbActivateĂ΂܂");
    }
    
    public void ejbPassivate() throws javax.ejb.EJBException, java.rmi.RemoteException {
        System.out.println("ShoppingCartBeanejbPassivateĂ΂܂");
    }
    
    public void ejbRemove() throws javax.ejb.EJBException, java.rmi.RemoteException {
        System.out.println("ShoppingCartBeanejbRemoveĂ΂܂");
    }
}
